<?php

namespace Dexanet\AwesomeCheckout\Plugin;

use Magento\Customer\Model\Session;

class AjaxLogin {

  /** @var \Magento\Framework\Controller\Result\JsonFactory */
  protected $resultJsonFactory;

  /** @var \Magento\Framework\App\Response\RedirectInterface */
  protected $redirect;

  /** @var \Magento\Customer\Model\Session */
  protected $customerSession;

  public function __construct(
    \Magento\Framework\Controller\Result\JsonFactory $jsonFactory,
    \Magento\Framework\App\Response\RedirectInterface $redirect,
    Session $customerSession
  ) {
    $this->resultJsonFactory = $jsonFactory;
    $this->redirect = $redirect;
    $this->customerSession = $customerSession;
  }

  /**
   * if the login was done in the checkout step it's necessary to redirect the
   * user to the checkout generic page to restart stepNavigator component
   *
   * @param \Magento\Customer\Controller\Ajax\Login $subject
   * @param $result
   *
   * @return \Magento\Framework\Controller\Result\Json
   */
  public function afterExecute(\Magento\Customer\Controller\Ajax\Login $subject, $result) {
    if ($this->customerSession->isLoggedIn() && preg_match("/checkout/", $this->redirect->getRedirectUrl())) {
      $response = [
        'errors' => FALSE,
        'message' => __('Login successful.'),
        'redirectUrl' => $this->redirect->getRedirectUrl(),
      ];

      $resultJson = $this->resultJsonFactory->create();
      return $resultJson->setData($response);
    }

    return $result;
  }
}