/**
 * @category Summit
 * @package Summit\Checkout
 * @copyright Copyright (c) 2016 Summit Media Limited (http://www.summit.co.uk/)
 * @license http://opensource.org/licenses/afl-3.0.php Academic Free License (AFL 3.0)
 */
define([
    'Magento_Checkout/js/view/payment',
    'jquery',
    'ko',
    'Magento_Checkout/js/model/quote',
    'mage/translate',
    'Magento_Checkout/js/model/step-navigator'
], function (payment, $, ko, quote, $t, stepNavigator) {
    'use strict';

    return payment.extend({
        defaults: {
            template: 'Dexanet_AwesomeCheckout/payment'
        },

        isVisible: ko.observable(quote.isVirtual() && window.isCustomerLoggedIn),

        customerClass: function () {
            if (window.isCustomerLoggedIn) {
                return 'checkout-payment-method customer';
            } else {
                return 'checkout-payment-method guest';
            }
        },

        initialize: function () {
            this._super();

            stepNavigator.registerStep(
                'confirmation',
                null,
                $t('Confirmation'),
                ko.observable(false),
                _.bind(this.navigate, this),

                /**
                 * sort order value
                 * 'sort order value' < 10: step displays before shipping step;
                 * 10 < 'sort order value' < 20 : step displays between shipping and payment step
                 * 'sort order value' > 20 : step displays after payment step
                 */
                21
            );
            return this;
        }
    });
});